IEC = LibStub("AceAddon-3.0"):NewAddon("InstanceEnteredCounter","AceEvent-3.0","AceConsole-3.0","AceTimer-3.0")
local AceDBOptions = LibStub("AceDBOptions-3.0")
local AceConfig = LibStub("AceConfig-3.0")
local AceConfigDialog= LibStub("AceConfigDialog-3.0", true)
local AceGui = LibStub("AceGUI-3.0")
local mainFrame
local Count 
local isInstanceCounterRunning
local isDead

local InstanceEnteredCounterLDB = LibStub("LibDataBroker-1.1"):NewDataObject("InstanceEnteredCounter", {
  type = "data source",
  Text = "Instance Entered Counter",
  icon = "Interface\\Icons\\Achievement_Dungeon_ClassicRaider.png",
  OnClick = function() IEC:ShowCounter() end
})
local icon = LibStub("LibDBIcon-1.0")

function InstanceEnteredCounterLDB.OnTooltipShow(tt)
  tt:AddLine("Instance Entered Counter.")
  tt:AddLine(" ")
  tt:AddLine("Left-Click to open the Instance Entered Counter.")
  tt:AddLine("Shift Left-Click to reset the counter.")
  tt:AddLine("Ctrl Left-Click to decrement the counter")
  tt:AddLine("in case you forgot to reset the instance before entering.")
  --[===[@debug@
  tt:AddLine("Alt Left-Click to increment the counter (For debugging use)")
  --@end-debug@]===]
  end

IECoptions = {
  name = "Instance Entered Counter",
  handler = IEC,
  type = 'group',
  args = {
    IECmainheader ={
      order = 1,
      name = "Main Settings",
      width = "double",
      type = "header",
    },
  }
}

local defaults = {
  global = {
     minimap = {
       hide = false
     }
    }
    }

function IEC:OnInitialize()
 IEC.db = LibStub("AceDB-3.0"):New("InstanceEnteredCounterDB", defaults, true)
 AceConfig:RegisterOptionsTable("IEC", IECoptions, {"iecsettings", "iecset"})
 AceConfigDialog:AddToBlizOptions("IEC", "Instance Entered Counter")
 icon:Register("InstanceEnteredCounter",InstanceEnteredCounterLDB, IEC.db.global.minimap)
end

function IEC:OnEnable()
IEC:RegisterEvent("PLAYER_ENTERING_WORLD","InstanceCheck") -- Fires when entering world
IEC:RegisterEvent("PLAYER_DEAD","DecrementCount") -- Fires when player dies.
isInstanceCounterRunning = 0
count = 0
isDead = 0
end

function IEC:OnDisable()
IEC:unregisterEvent("PLAYER_ENTERING_WORLD")
IEC:unregisterEvent("PLAYER_DEAD")
end

function IEC:ShowCounter() 

if IsShiftKeyDown() then
if isInstanceCounterRunning == 1 then
mainFrame:SetTitle("Times Entered: 0/10")  Count = 0
end
elseif IsControlKeyDown() then
if isInstanceCounterRunning == 1 then
		Count = Count - 1
		mainFrame:SetTitle("Times Entered: ".. Count .."/10")
end
--[===[@debug@
 elseif IsAltKeyDown() then
 if isInstanceCounterRunning == 1 then
        Count = Count +1
        mainFrame:SetTitle("Times Entered: ".. Count .."/10")
 end
 --@end-debug@]===]
else 
IEC:SetupFrame()
end
end 

function IEC:SetupFrame()
if isInstanceCounterRunning == 1 then return end
isInstanceCounterRunning = 1

mainFrame = AceGui:Create("Frame")
mainFrame:SetLayout("Flow")
mainFrame:SetCallback("OnClose",function(widget) AceGui:Release(widget) mainFrame:SetTitle("Times Entered: 0/10")  Count = 0  isInstanceCounterRunning = 0 end )
mainFrame:SetPoint("CENTER",0,100)
mainFrame:SetWidth(150)
mainFrame:SetHeight(60)
mainFrame:EnableResize(false)
mainFrame:SetTitle("Times Entered: 0/10")
end

function IEC:IncrementCount()
	local name, ftype, difficultyIndex, difficultyName, maxPlayers, dynamicDifficulty,
	isDynamic, mapID = GetInstanceInfo()

		if ftype  == "party" or ftype == "raid" then
			if isInstanceCounterRunning == 1 then
			Count = Count + 1
			mainFrame:SetTitle("Times Entered: ".. Count .."/10")
			isDead = 0
			end 
		end
end

--Decrements  the count when you die  because if you go back to the 
--instance it would increment up again messing up the count.
--AKA  5/10 dies (run not finished)  count now 4/10 reenters instance count back to 5/10.
--If it didn't decrement the count at death the count would be 11/10 or 13/10 depending how many times you died.
function IEC:DecrementCount()
if isInstanceCounterRunning == 1 then
    if isDead == 0 then
			Count = Count - 1
			mainFrame:SetTitle("Times Entered: ".. Count .."/10")
			isDead = 1
	end
end
end

function IEC:InstanceCheck()
IEC:ScheduleTimer("IncrementCount" ,2)
end